//+------------------------------------------------------------------+
//|                                                  MACD Sample.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#define version "2.6b1"
#define PROGNAME "MACD-dsy"
#define _MAGIC 6223379   // MACDdsy


/* Optimized
GBP/H4 90-5-60-3-3 (from: 2005/1~2007/1)
GBP/H4 90-2.7-60-3-3 (from: 2006/1~2007/1)
   90-4.2-65-3-3 for $8,000 deposit (2005~)
   90-2.2-65-3-3 for $8,000 deposit (2006~) 
   90-2.5-70-3-3 for $11,000 deposit (2006~) 
---1.7v
15m
   110-5.6-60-5-1-500 for $11,000 deposit (2005~) demo
   90-5.8-65-5-1-400 for $11,000 deposit (2005~) Live
   110-3-65-5-1-400/0 for $12,000 deposit (2006~) demo
   110-3.5-65-5-1-400/0 for $12,000 deposit (2006~) Live
---2.0b1
   300-3.7-30-8-13-130 for $12,000 deposit (2006/5~) demo
   340-x-25-3-4-19-190
   320-x-25-1-4-19-300
   310-3.4-25-3-1-19-190
   310-?-25-4-1-18-190
   280-?-25-4-1-18-360

GBP/H1

CHF/H4 70-9-10-3-2 (from: 2006/1~2007/1)
CHF/H4 130-7-10-3-3 (from: 2005/1~2007/1)
   170-2.3-20-3-3 for $3,000 deposit (2005~)
   170-2.8-20-3-3 for $3,000 deposit (2006~)
   170-4.9-20-3-3 for $5,000 deposit (2006~)
   170-7.8-20-3-3 for $8,000 deposit (2006~)
   
EUR-H4-50-20   
*/
extern bool ReverseOnFail = true;
extern bool MACDSignal = true;
extern int  MACDSignalHS = 190;
extern bool EMATurned = true;
extern int EMATurnedHS = 110;
extern int EMATurnDV = 2;
extern bool MACDdiverg = false;
extern int MACDdiverHS = 0;
extern bool LWMACross = false;
extern int LWMACrossHS = 0;
extern int LWMAdistance = 20;

extern double TakeProfit1 = 60;
//extern double TakeProfit2 = 0;
extern double AllLots=1;
extern double Lot1pct = 1;
//extern double Lot2 = 1;
//extern double Lot3 = 1;
extern bool MACDexit = true;
extern double TrailingStop1 = 30;
extern double TrailingStop2 = 30;
//extern double TrailingStop3 = 30;
int Hardstop=0;
//extern double SARstep = 0.02;
//extern double SARmax = 0.2;
//extern double SARSigLevel = 4;
extern double MATrendPeriod=19;
extern double MACDOpenLevel=1;
extern double MACDCloseLevel=20;
extern int TF=240;
extern int FractalDV = 15;
extern int  TrailingPeriod = 0;
extern int  EntryPeriod = 0;
extern int TradeLifeHours = 0;
extern double MACDLong=12;
extern double MACDShort=26;
extern double MACDMid=9;
extern int OpenSlip=10;
extern int CloseSlip=10;
extern bool TradeEmail=true;
extern bool LogDetail=true;
extern bool ErrorEmail=true;
extern bool ErrorAlert=true;
extern bool SoundOn=true;
extern bool MagicOnly=true;
extern int TradeTimeOut=60;
/*
extern bool useATRstop=false;
extern int ATRMultiplier=3;
*/
int lotsize;
int LTime=0, TSTime=0, ENTime=0, STime=0;
string LastTrade="";
int total;
string control, progid;
int leverage;
double _MacdCurrent, _MacdPrevious, _SignalCurrent, _Macd3, _Macd0;
double _SignalPrevious, _MaCurrent, _MaPrevious, _Ma3, _MaDay1, _MaDay2;   
double AriefMain1, AriefMain2, AriefShift1, AriefShift2, AriefEMA5_1, AriefEMA5_2, AriefEMA50;
bool AriefCandleUp, AriefCandleDown, AriefTrading=false;
int AriefRSI;
double Fup[3], Fdn[3], _high1, _low1;
int _time0;
int cnt, ticket, tradetime, lasttic=0;
int Magic;
double Lot1, Lot2;
   
void NotifyTrade(string msg, int tic, double P) {
string mailtext="";

   if (IsTesting()) return;
   if (StringSubstr(msg,0,5)=="Close") {
      msg="MACD-dsy|"+Symbol()+" "+msg+" #"+tic;
      mailtext=msg+"\n@ Market Price="+DoubleToStr(P,Digits);
   }
   if (StringSubstr(msg,0,4)=="Open") {
      msg="MACD-dsy|"+Symbol()+" "+msg+" #"+tic;
      mailtext=msg+"\n@ Market Price="+DoubleToStr(P,Digits);
   }
   if (StringSubstr(msg,0,6)=="Modify") {
      msg="MACD-dsy|"+Symbol()+" "+msg+" #"+tic;
      mailtext=msg+"\n@ SL="+DoubleToStr(P,Digits);
   }
   mailtext="GMT Time:"+TimeToStr(LocalTime())+"\n"+mailtext;
   if (TradeEmail) SendMail(msg,mailtext);
   if (LogDetail && !IsTesting()) Print("MACD-dsy|"+Symbol()+Period()+"\n"+msg);
   LastTrade="\n\nLatestTrade:\n"+mailtext;
}

void NotifyErr(string M, int err) {
string msg="\nGMT:"+TimeToStr(LocalTime());

   if (IsTesting()) return;
   if (ErrorAlert) Alert("MACD-dsy|"+Symbol()+M+",err="+ErrMessage(err)+msg);
   if (ErrorEmail) SendMail("MACD-dsy|"+Symbol()+Period()+M+",err="+ErrMessage(err), M);
   if (LogDetail && !IsTesting()) Print("MACD-dsy|"+Symbol()+Period()+"\n"+M);
   if (SoundOn) PlaySound("expert.wav");
   if (LogDetail && !IsTesting()) Print("MACD-dsy|"+Symbol()+Period()+"\n"+msg);
   LastTrade="\n\nERROR:"+M+"\nExecution@"+TimeToStr(TimeCurrent());   
}

string ErrMessage(int err) {
   switch(err){
   case 0: return("(0)NO_ERROR");
   case 1: return("(1)NO_RESULT");
   case 129: return("(129)INVALID_PRICE");
   case 130: return("(130)INVALID_STOPS");
   case 131: return("(131)INVALID_TRADE_VOLUME");
   case 132: return("(132)MARKET_CLOSED");
   case 133: return("(133)TRADE_DISABLED");
   case 134: return("(134)NOT_ENOUGH_MONEY");
   case 135: return("(135)ERR_PRICE_CHANGED");
   case 136: return("(136)ERR_OFF_QUOTES");   
   case 138: return("(138)ERR_REQUOTE");        
   default: return("("+err+")");
   }
}

void PeriodlyFetch() {


//   control=total;
   
   _MacdCurrent=iMACD(NULL,TF,MACDLong,MACDShort,MACDMid,PRICE_CLOSE,MODE_MAIN,1);
   _MacdPrevious=iMACD(NULL,TF,MACDLong,MACDShort,MACDMid,PRICE_CLOSE,MODE_MAIN,2);
   _Macd3=iMACD(NULL,TF,MACDLong,MACDShort,MACDMid,PRICE_CLOSE,MODE_MAIN,3);
   _Macd0=iMACD(NULL,TF,MACDLong,MACDShort,MACDMid,PRICE_CLOSE,MODE_MAIN,0);
   _SignalCurrent=iMACD(NULL,TF,MACDLong,MACDShort,MACDMid,PRICE_CLOSE,MODE_SIGNAL,1);
   _SignalPrevious=iMACD(NULL,TF,MACDLong,MACDShort,MACDMid,PRICE_CLOSE,MODE_SIGNAL,2);
   _MaCurrent=iMA(NULL,TF,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,1);
   _MaPrevious=iMA(NULL,TF,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,2); 
   _Ma3=iMA(NULL,TF,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,3); 


   _high1=iHigh(NULL, TF, 1);
   _low1=iLow(NULL, TF, 1);
//   _time0=iTime(Symbol(),TF,0);
}

/*
double ATRSL(int B) {
 return(iATR(NULL,0,14,B)*ATRMultiplier);
}
*/

int ModifyStoploss(int Pos, int TS) {
double _TS;

   if (TS==0) return(0);
   else _TS=TS*Point;
   switch(Pos){
   case OP_BUY:
      if(Bid-OrderOpenPrice()>_TS) {
         if (OrderMagicNumber()==Magic+2) {
            if(OrderStopLoss()==0) {
               OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()+_TS,Digits),OrderTakeProfit(),0,Aqua);
               LastTrade=LastTrade+"\nModify #"+OrderTicket()+",SL="+DoubleToStr(OrderOpenPrice()+_TS,Digits)+"\n@Server Time:"+TimeToStr(TimeCurrent());
               control=control+"\nModified SL@"+DoubleToStr(OrderOpenPrice()+_TS,Digits);
            }
         } else {
            if(OrderStopLoss()<Bid-_TS || OrderStopLoss()==0) {
               RefreshRates();                    
               OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid-_TS,Digits),OrderTakeProfit(),0,Aqua);
               LastTrade=LastTrade+"\nModify #"+OrderTicket()+",SL="+DoubleToStr(Bid-_TS,Digits)+"\n@Server Time:"+TimeToStr(TimeCurrent());
               control=control+"\nModified SL@"+DoubleToStr(Bid-_TS,Digits);
            }
         }
      }
      break;
   case OP_SELL:
      if(OrderOpenPrice()-Ask>_TS) {
         if (OrderMagicNumber()==Magic+2) {      
            if(OrderStopLoss()==0) {
               OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()-_TS,Digits),OrderTakeProfit(),0,Aqua);
               LastTrade=LastTrade+"\nModify #"+OrderTicket()+",SL="+DoubleToStr(OrderOpenPrice()-_TS,Digits)+"\n@Server Time:"+TimeToStr(TimeCurrent());
               control=control+"\nModified SL@"+DoubleToStr(OrderOpenPrice()-_TS,Digits);
            }         
         } else {
            if(OrderStopLoss()>Ask+_TS || OrderStopLoss()==0) {
               RefreshRates();                    
               OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask+_TS,Digits),OrderTakeProfit(),0,Aqua);
               LastTrade=LastTrade+"\nModify #"+OrderTicket()+",SL="+DoubleToStr(Ask+_TS,Digits)+"\n@Server Time:"+TimeToStr(TimeCurrent());
               control=control+"\nModified SL@"+DoubleToStr(Ask+_TS,Digits);
            }
         }
      }
      break;
   }
   return(GetLastError());
}

bool LastFailed(int op) {

   if (!OrderSelect(lasttic, SELECT_BY_TICKET)) return(false);
   if (OrderCloseTime()==0) return(false);
   if (OrderType()==op) {
      if (OrderProfit()<0) return(true);
   }
   return(false);
}

bool ExitSignal(int op) {
   switch(op) {
   case OP_BUY:
      if (MACDexit && !AriefTrading &&
         MathAbs(_MacdCurrent)>(MACDCloseLevel*Point) 
         && (_Macd3<_MacdPrevious && _MacdCurrent < _MacdPrevious 
         && _SignalCurrent>0 && _SignalCurrent < _MacdCurrent)
         )
         return(true);
      break;
   case OP_SELL:
      if (MACDexit && !AriefTrading &&
         MathAbs(_MacdCurrent)>(MACDCloseLevel*Point) 
         && _Macd3>_MacdPrevious && _MacdCurrent > _MacdPrevious && _SignalCurrent<0 && _SignalCurrent > _MacdCurrent
         )
         return(true);
      break;
   }
   return(false);
}

void MaintainTrade() {
double SL=0;

   control="";  LastTrade="\n";
   for(cnt=OrdersTotal();cnt>0;cnt--)
     {
      OrderSelect(cnt-1, SELECT_BY_POS, MODE_TRADES);
      if (MagicOnly && (OrderMagicNumber()<Magic || OrderMagicNumber()>Magic+1)) continue;      
      if (OrderSymbol()!=Symbol()) continue;  // check for symbol
      if(OrderType()<=OP_SELL)  // check for opened position 
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            control=control+"\nBuy #"+OrderTicket()+" ("+DoubleToStr((Bid-OrderOpenPrice())/Point,0)+" pips)";
            if(ExitSignal(OP_BUY))
                {

                  CloseTrade(OP_BUY, Bid, "Close Buy");
                  // close position
                  control=control+"\nClosed.";
                  continue;
                }
            // check for trailing stop

            if (OrderMagicNumber()==Magic) ModifyStoploss(OP_BUY, TrailingStop1);
//            if (OrderMagicNumber()==Magic+2) ModifyStoploss(OP_BUY, TrailingStop2);
            if (OrderMagicNumber()==Magic+1) ModifyStoploss(OP_BUY, TrailingStop2);
     
           }
         else // go to short position
           {
            control=control+"\nSell #"+OrderTicket()+" ("+DoubleToStr((OrderOpenPrice()-Ask)/Point,0)+" pips)";
            // should it be closed?
            if(ExitSignal(OP_SELL))
              {
               CloseTrade(OP_SELL, Ask, "Close Sell");
               control=control+"\nClosed.";
               continue;
              }
            // check for trailing stop
            if (OrderMagicNumber()==Magic) ModifyStoploss(OP_SELL, TrailingStop1);
//            if (OrderMagicNumber()==Magic+2) ModifyStoploss(OP_SELL, TrailingStop2);
            if (OrderMagicNumber()==Magic+1) ModifyStoploss(OP_SELL, TrailingStop2);
           }
        }
     }
//     if (LastTrade!="\n") Print (LastTrade);
}     

int CloseTrade (int Pos, double P, string Comm) {
string notify;

     NotifyTrade(Comm,OrderTicket(),Bid);
     tradetime=TimeCurrent();               
     while (!OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(P,Digits),CloseSlip,Yellow)){
         if (TimeCurrent()-tradetime > TradeTimeOut) {
            NotifyErr(Comm+DoubleToStr(Bid,Digits),GetLastError());
            break;
         }
         Sleep(500);
         RefreshRates();              
         switch(Pos){
         case OP_BUY:
            P=Bid; break;
         case OP_SELL:
            P=Ask; break;
         }
     }                  
     return(GetLastError());
}

int OpenTrade(int M, int Pos, double L, double HS, double TP, string Comm) {
double P; string notify; int col;

   ticket=0; tradetime=TimeCurrent();
   while(ticket<=0) {
      RefreshRates();
      switch(Pos) {
      case OP_BUY:
         P=Ask ; notify="Open Buy"; col=Green; break;
      case OP_SELL:
         P=Bid ; notify="Open Sell"; col=Red; break;
      }
      ticket=OrderSend(Symbol(),Pos,NormalizeDouble(L,1),NormalizeDouble(P,Digits),OpenSlip,NormalizeDouble(HS,Digits),NormalizeDouble(TP,Digits),Comm,M,0,col);
      if(ticket>0)
         if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) { 
            NotifyTrade(notify,ticket,OrderOpenPrice());
            lasttic=ticket;
            return(0);
          }
      if (TimeCurrent()-tradetime < TradeTimeOut) { Sleep(500); continue; }
      NotifyErr(notify+DoubleToStr(P,Digits),GetLastError());
   }
   return(GetLastError());
}

int init() {
   lotsize=MarketInfo(Symbol(),MODE_LOTSIZE)/1000;
   leverage=AccountLeverage();
   Magic=_MAGIC+func_Symbol2Val(Symbol())*100 + func_TimeFrame_Const2Val(TF)*10;
   
   if (TakeProfit1==0) TakeProfit1=999;
   
   Fup[0]=0; Fup[1]=0; Fup[2]=0; Fdn[0]=0;  Fdn[1]=0;  Fdn[2]=0; 

   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   Lot1=AllLots*Lot1pct; Lot2=AllLots*(1-Lot1pct);
   if(!IsTesting()) Comment(CookComment());      
}

int deinit() {
   Comment("");
}

bool AllowEntry(int P) {
   
   AriefTrading=false;
   switch(P) {
   case OP_BUY:
/*   
      if ((LWMAMain1-LWMAShift1)<0 || Ask<LWMAMain1
         ) return(false);
*/         
      if (ReverseOnFail && LastFailed(OP_SELL))
      { Hardstop = MACDSignalHS; progid=PROGNAME+" "+version+".FailRevert"; return(true); }
      if (MACDSignal &&
         _MacdCurrent<0 && _MacdCurrent>=_SignalCurrent && _MacdPrevious<_SignalPrevious
         && MathAbs(_MacdCurrent)>(MACDOpenLevel*Point) && _MaCurrent>_MaPrevious
         /*&& (Ask<Open[0]-TakeProfit1*Point*2)*/ /*&& (_MaCurrent-LWMA_F1)/Point>LWMAdistance*/
         )
         { Hardstop = MACDSignalHS; progid=PROGNAME+" "+version+".Signal"; return(true); }
      if (EMATurned &&
         _MaCurrent-_MaPrevious>(_Ma3-_MaPrevious+EMATurnDV*Point) && _high1<Fup[0] && _high1<Fup[1] && _high1<Fup[2]
         && (Fdn[0]>Fdn[1] || Fup[0]>Fup[1]) && _MacdCurrent > _MacdPrevious && _SignalCurrent<0 && _SignalCurrent<_MacdCurrent
         && MathAbs(Fup[0]-Fup[1])>FractalDV*Point && MathAbs(Fup[1]-Fup[2])>FractalDV*Point  && MathAbs(Fup[0]-Fup[2])>FractalDV*Point
         && Close[0]>iMA(NULL,TF,50,0,MODE_EMA,PRICE_CLOSE,1))
         { Hardstop = EMATurnedHS; progid=PROGNAME+" "+version+".EMAturn"; return(true); }

      if (MACDdiverg && // suspend
         _MacdPrevious<_SignalPrevious && _MacdCurrent>_MacdPrevious && _SignalCurrent<_MacdCurrent
         && (_Macd3-_MacdPrevious)<( _MacdCurrent-_MacdPrevious) && _SignalCurrent<_SignalPrevious
         && _MaCurrent>_MaPrevious && (Fdn[0]>Fdn[1] && Fdn[1]>Fdn[2] && Fup[0]>Fup[1])
         )
         { Hardstop = MACDdiverHS; progid=PROGNAME+" "+version+".Diverg"; return(true); }
            
      break;

   case OP_SELL:
/*  
      if ((LWMAMain1-LWMAShift1)>0 || Bid>LWMAMain1
         ) return(false);
*/         
      if (ReverseOnFail && LastFailed(OP_BUY))
      { progid=PROGNAME+" "+version+".FailRevert"; return(true); }
      if (MACDSignal &&
         _MacdCurrent>0 && _MacdCurrent<=_SignalCurrent && _MacdPrevious>_SignalPrevious && 
         _MacdCurrent>(MACDOpenLevel*Point)  && _MaCurrent<_MaPrevious /*&& (LWMA_F1-_MaCurrent)/Point>LWMAdistance*/
         )
         { Hardstop = MACDSignalHS; progid=PROGNAME+" "+version+".Signal"; return(true); }
                 
      if (EMATurned &&
         _MaPrevious-_MaCurrent>(_MaPrevious-_Ma3+EMATurnDV*Point) && _low1>Fdn[0] && _low1>Fdn[1] && _low1>Fdn[2]
         && (Fdn[0]<Fdn[1] || Fup[0]<Fup[1]) && _MacdCurrent < _MacdPrevious && _SignalCurrent>0 && _SignalCurrent>_MacdCurrent
         && MathAbs(Fdn[0]-Fdn[1])>FractalDV*Point && MathAbs(Fdn[1]-Fdn[2])>FractalDV*Point  && MathAbs(Fdn[0]-Fdn[2])>FractalDV*Point 
         && Close[0]<iMA(NULL,TF,50,0,MODE_EMA,PRICE_CLOSE,1))
         { Hardstop = EMATurnedHS; progid=PROGNAME+" "+version+".EMAturn";  return(true); }

      if (MACDdiverg && // suspend
         _MacdPrevious>_SignalPrevious && _MacdCurrent<_MacdPrevious && _SignalCurrent>_MacdCurrent
         && (_Macd3-_MacdPrevious)>( _MacdCurrent-_MacdPrevious) && _SignalCurrent>_SignalPrevious
         && _MaCurrent<_MaPrevious && (Fdn[0]<Fdn[1] && Fdn[1]<Fdn[2] && Fup[0]<Fup[1])
         )
         { Hardstop = MACDdiverHS; progid=PROGNAME+" "+version+".Diverg"; return(true); }
      
      break;
   }
   return(false);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int main()
  {


// initial data checks
// it is important to make sure that the expert works with a normal
// chart and the user did not make any mistakes setting external 
// variables (Lots, StopLoss, TakeProfit, 
// TrailingStop) in our case, we check TakeProfit
// on a chart of less than 100 bars

// to simplify the coding and speed up access
// data are put into internal variables
/*
   int t1=0, t2=0;
   for (total=OrdersTotal();total>0;total--){
      if (OrderSelect(total-1,SELECT_BY_POS, MODE_TRADES)==false) { continue; }
      if (Symbol()!=OrderSymbol()) { continue; }
      if (OrderMagicNumber()< Magic || OrderMagicNumber()> Magic+1){ continue; }
      if (OrderMagicNumber()==Magic) t1++;
      if (OrderMagicNumber()==Magic+1) t2++;
//      break;
   }   
*/   
   if ((!OrderSelect(lasttic, SELECT_BY_TICKET) || OrderCloseTime()>0) && LTime!=0)
     {
      // check for long position (BUY) possibility
      if(AllowEntry(OP_BUY))
        {
         // no opened orders identified
         if(AccountFreeMargin()<(500*(Lot1+Lot2)))
           {
            Alert(Symbol()+": No Free Margin!! "+Period());
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            NotifyTrade("Open Buy",0,OrderOpenPrice());
            return(0);  
           }
         if (Lot1!=0) {
            if (Hardstop==0) OpenTrade(Magic, OP_BUY, Lot1, 0, Ask+TakeProfit1*Point, progid);
            else OpenTrade(Magic, OP_BUY, Lot1, Bid-Hardstop*Point, Ask+TakeProfit1*Point, progid);
         }
/*
         if (Lot1!=0 && t1==0 && t2>0)
            if (Hardstop==0) OpenTrade(Magic, OP_BUY, Lot1/2, 0, Ask+TakeProfit1*Point, PROGNAME+"-1stHalf");
            else OpenTrade(Magic, OP_BUY, Lot1/2, Bid-Hardstop*Point, Ask+TakeProfit1*Point, PROGNAME+"-1stHalf");

         if (Lot3!=0)
            if (Hardstop==0) OpenTrade(Magic+1, OP_BUY, Lot2, 0, Ask+TakeProfit2*Point, PROGNAME+"-2nd");
            else OpenTrade(Magic+1, OP_BUY, Lot2, Bid-Hardstop*Point, Ask+TakeProfit2*Point, PROGNAME+"-2nd");
*/            
         if (Lot2!=0) {
            if (Hardstop==0) OpenTrade(Magic+1, OP_BUY, Lot2, 0, 0, progid);
            else OpenTrade(Magic+1, OP_BUY, Lot2, Bid-Hardstop*Point, 0, progid);
         }
         return(0); 
        }
      // check for short position (SELL) possibility
      if(AllowEntry(OP_SELL))
        {
         // no opened orders identified
         if(AccountFreeMargin()<(500*(Lot1+Lot2)))
           {
            Alert(Symbol()+": No Free Margin!! "+Period());
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            NotifyTrade("Open Sell",0,OrderOpenPrice());            
            return(0);  
           }
         if (Lot1!=0) {
            if (Hardstop==0) OpenTrade(Magic, OP_SELL, Lot1, 0, Bid-TakeProfit1*Point, PROGNAME+"-1st");
            else OpenTrade(Magic, OP_SELL, Lot1, Ask+Hardstop*Point, Bid-TakeProfit1*Point, PROGNAME+"-1st");
         }
/*
         if (Lot1!=0 && t1==0 && t2>0)
            if (Hardstop==0) OpenTrade(Magic, OP_SELL, Lot1/2, 0, Bid-TakeProfit1*Point, PROGNAME+"-1stHalf");
            else OpenTrade(Magic, OP_SELL, Lot1/2, Ask+Hardstop*Point, Bid-TakeProfit1*Point, PROGNAME+"-1stHalf");

         if (Lot3!=0)
            if (Hardstop==0) OpenTrade(Magic+1, OP_SELL, Lot2, 0, Bid-TakeProfit2*Point, PROGNAME+"-2nd");
            else OpenTrade(Magic+1, OP_SELL, Lot2, Ask+Hardstop*Point, Bid-TakeProfit2*Point, PROGNAME+"-2nd");
*/
         if (Lot2!=0) {
            if (Hardstop==0) OpenTrade(Magic+1, OP_SELL, Lot2, 0, 0, PROGNAME+"-2nd");
            else OpenTrade(Magic+1, OP_SELL, Lot2, Ask+Hardstop*Point, 0, PROGNAME+"-2nd");
         }

         return(0); 
        }
//      return(0);
     }
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly... 
   return(0);
  }
  
string CookComment() {  
string msg;

   msg="ACC# "+AccountNumber()+" ["+AccountName()+" | $"+DoubleToStr(AccountBalance(),0)+" {$"+DoubleToStr(AccountEquity()-AccountBalance(),0)+"} | "+leverage+":1 | "+lotsize+"K]";
   msg=msg+"\nFreeMargin=$"+DoubleToStr(AccountFreeMargin(),0)+" (+used: $"+DoubleToStr(AccountMargin(),0)+") | "+DoubleToStr(AccountFreeMargin()/(Ask*(lotsize*1.0/leverage)/Point/10),1)+" Lots x $"+DoubleToStr(Ask*(lotsize*1.0/leverage)/Point/10,1);
   msg=msg+" | "+DoubleToStr(AccountFreeMargin()/(Ask*(lotsize*1.0/leverage)/Point/10+MACDSignalHS*10),1)+" Lots x $"+DoubleToStr(Ask*(lotsize*1.0/leverage)/Point/10+MACDSignalHS*10,1);
//   msg=msg+"\nGMT Time: "+TimeToStr(LocalTime());
//   msg=msg+"\nServer Time: "+TimeToStr(TimeCurrent());
//   msg=msg+"\nCurrent Bar="+TimeToStr(Time[0]);
   msg=msg+"\nLot1="+DoubleToStr(Lot1,1)+", Lot2="+DoubleToStr(Lot2,1) /*+", Lot3="+DoubleToStr(Lot3,1)*/;
   msg=msg+", TP="+DoubleToStr(TakeProfit1,0)/*+", TP2="+DoubleToStr(TakeProfit2,0)*/;
   msg=msg+", TS="+DoubleToStr(TrailingStop1,0)/*+", TS2="+DoubleToStr(TrailingStop2,0)+", TS3="+DoubleToStr(TrailingStop3,0)*/;
   if (MACDSignal) msg=msg+"\nMACDSignal Enabled, HS="+MACDSignalHS;
   if (EMATurned) msg=msg+"\nEMATurned Enabled, HS="+EMATurnedHS;
   msg=msg+"\nEMATurnDV="+EMATurnDV+", FractalDV="+FractalDV;
/*
   msg=msg+"\nMagicOnly="+MagicOnly+",TradeEmail="+TradeEmail+"\nErrorAlert="+ErrorAlert+",SoundOn="+SoundOn;
   msg=msg+"\nTrailingPeriod="+TrailingPeriod+", EntryPeriod="+EntryPeriod;
*/   
   msg=msg+"\nControlled Trade:"+control;
   msg=msg+LastTrade;
   msg=msg+"\nversion "+version+"\n(magic base #"+Magic+")";
   return (msg);

} 
/*
string func_TimeFrame_Val2String(int Value ) {
   switch(Value) {
      case 1:  // M1
         return("PERIOD_M1");
      case 2:  // M1
         return("PERIOD_M5");
      case 3:
         return("PERIOD_M15");
      case 4:
         return("PERIOD_M30");
      case 5:
         return("PERIOD_H1");
      case 6:
         return("PERIOD_H4");
      case 7:
         return("PERIOD_D1");
      case 8:
         return("PERIOD_W1");
      case 9:
         return("PERIOD_MN1");
   	default: 
   		return("undefined " + Value);
   }
}
*/
int func_Symbol2Val(string symbol) {
	if(symbol=="AUDCAD") {
		return(1);
	} else if(symbol=="AUDJPY") {
		return(2);
	} else if(symbol=="AUDNZD") {
		return(3);
	} else if(symbol=="AUDUSD") {
		return(4);
	} else if(symbol=="CHFJPY") {
		return(5);
	} else if(symbol=="EURAUD") {
		return(6);
	} else if(symbol=="EURCAD") {
		return(7);
	} else if(symbol=="EURCHF") {
		return(8);
	} else if(symbol=="EURGBP") {
		return(9);
	} else if(symbol=="EURJPY") {
		return(10);
	} else if(symbol=="EURUSD") {
		return(11);
	} else if(symbol=="GBPCHF") {
		return(12);
	} else if(symbol=="GBPJPY") {
		return(13);
	} else if(symbol=="GBPUSD") {
		return(14);
	} else if(symbol=="NZDUSD") {
		return(15);
	} else if(symbol=="USDCAD") {
		return(16);
	} else if(symbol=="USDCHF") {
		return(17);
	} else if(symbol=="USDJPY") {
		return(18);
	} else {
		Comment("unexpected Symbol");
		return(0);
	}
}

int func_TimeFrame_Const2Val(int Constant ) {
   switch(Constant) {
      case 1:  // M1
         return(1);
      case 5:  // M5
         return(2);
      case 15:
         return(3);
      case 30:
         return(4);
      case 60:
         return(5);
      case 240:
         return(6);
      case 1440:
         return(7);
      case 10080:
         return(8);
      case 43200:
         return(9);
   }
}	

void SearchFractal() {
int i, fupi=0, fdni=0;
double _f;   

   for (i=3 ; i<Bars-1; i++) {
      if (fupi<3) {
         _f=iFractals(NULL, TF, MODE_UPPER,i);
         if (_f!=0) {
            Fup[fupi]=_f;
            fupi++;
         }
      }         
      if (fdni<3) {
         _f=iFractals(NULL, TF, MODE_LOWER,i);
         if (_f!=0) {
            Fdn[fdni]=_f;
            fdni++;
         }
      }
      if (fupi+fdni==6) break;
   }
}

int FindLastTicket() {
int i;

   for (i=OrdersTotal();i>0;i--){
      if (OrderSelect(i-1,SELECT_BY_POS, MODE_TRADES)==false) { continue; }
      if (Symbol()!=OrderSymbol()) { continue; }
      if (OrderMagicNumber()!=Magic){ continue; }
      break;
   }
   if (i>0) return(OrderTicket());

int s=0;   
   for (i=OrdersHistoryTotal(); i>0 ; i--) {
      if (OrderSelect(i-1,SELECT_BY_POS, MODE_HISTORY)==false) { continue; }
      if (OrderOpenTime()<s) { continue; }
      if (Symbol()!=OrderSymbol()) { continue; }
      if (OrderMagicNumber()!=Magic){ continue; }
      s=OrderOpenTime();
   }
   if (s>0) return(OrderTicket());
   else return(0);
}
 
int start() {
string m="";

   if (LTime!=Time[1]) {
      LTime=Time[1];
      TSTime=LTime;
      ENTime=LTime;
      SearchFractal();
      PeriodlyFetch();
   }
  
   if (lasttic==0) lasttic=FindLastTicket();
   if (TimeCurrent()-ENTime > EntryPeriod*60) {
      main();
      ENTime=TimeCurrent();
   }
   if (TimeCurrent()-TSTime > TrailingPeriod*60) {
      MaintainTrade();
      TSTime=TimeCurrent();
   }
   if(!IsTesting()) Comment(CookComment()); 

}  
// the end.